unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Spin, Grids;

type

  TDataRecord = record
    ID: Integer;
    RecType: Integer;
    Ticket: Integer;
    Price: Single;
    Comments: String[255];
  end;

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    edComments: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    seID: TSpinEdit;
    sePrice: TFloatSpinEdit;
    seType: TSpinEdit;
    seTicket: TSpinEdit;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;
  DataFile: String = 'Test_Data.txt';

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  F: TextFile;
begin
  // Am Anfang sollte man noch prüfen, ob überhaupt etwas geschrieben werden
  // soll, also ob überhaupt Einträge vorhanden sind, und dass die Integer
  // und Float-Felder gültige Zahlen sind. Aber das will ich hier nicht ausführen.

  AssignFile(F, DataFile);
  // Datei erzeugen/öffnen
  if not FileExists(DataFile) then
    Rewrite(F)                // Neue Datei anlegen
  else
    Append(F);                // An bestehende Datei anhängen
  // Aktuellen Datensatz ans Ende der Datei schreiben
  WriteLn(F, seID.Value, #9, seType.Value, #9, seTicket.Value, #9, sePrice.Value:0:2, #9, edComments.Text);
  CloseFile(F);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  L: TStringList;
  sa: TStringArray;
  i, j: Integer;
begin
  L := TStringList.Create;
  try
    // Komplette Datei in eine StringList einlesen
    L.LoadFromFile(DataFile);
    // StringGrid für Anzeige vorbereiten
    StringGrid1.RowCount := L.Count + StringGrid1.FixedRows;
    StringGrid1.ColCount := 6;
    StringGrid1.Cells[1, 0] := 'ID';
    StringGrid1.Cells[2, 0] := 'Type';
    StringGrid1.Cells[3, 0] := 'Ticket';
    StringGrid1.Cells[4, 0] := 'Price';
    StringGrid1.Cells[5, 0] := 'Comments';
    for i := 0 to L.Count-1 do
    begin
      // Jeden Eintrag der StringList am Tabulator auftrennen und Teile im StringArray sa ablegen
      sa := L[i].Split(#9);
      // Die aufgeteilte Stringlist in die Zellen des StringGrid schreiben.
      // Dabei darauf achten, dass auf das Grid nicht über die letzte Spalte hinaus zugegriffen wird.
      for j := 0 to Length(sa)-1 do
        if j < StringGrid1.ColCount-1 then
          StringGrid1.Cells[j+1, i+1] := sa[j];
      // Laufende Nummer in die erste (feste) Spalte schreiben
      StringGrid1.Cells[0, i+1] := IntToStr(i);
    end;
    // Spalte für die Comments breiter machen
    StringGrid1.ColWidths[StringGrid1.ColCount-1] := 150;
  finally
    L.Free;
  end;
end;

end.

